<< problem 563 - Robot Welders | Super Pandigital Numbers - problem 571 >> |
Problem 565: Divisibility of sum of divisors
(see projecteuler.net/problem=565)
Let sigma(n) be the sum of the divisors of n.
E.g. the divisors of 4 are 1, 2 and 4, so sigma(4)=7.
The numbers n not exceeding 20 such that 7 divides sigma(n) are: 4,12,13 and 20, the sum of these numbers being 49.
Let S(n,d) be the sum of the numbers i not exceeding n such that d divides sigma(i).
So S(20,7)=49.
You are given: S(10^6,2017)=150850429 and S(10^9,2017)=249652238344557
Find S(10^11,2017).
My Algorithm
The Wikipedia page about the Divisor Function has a few useful formulas (see en.wikipedia.org/wiki/Divisor_function):
(1) \sigma_1(p) = p + 1 if p is prime
(2) \sigma_1(p^k) = dfrac{p^{k+1} - 1}{p - 1} if p is prime
(3) \sigma_1(m * n) = \sigma_1(m) * \sigma_1(n) if m and n are coprime
The most crucial observation is that if \sigma_1(m) is divisible by 2017, then according to (3) almost every multiple is, too
(the exception is when m and n are not coprime, for example for m = n).
My function search()
starts with equation (2) (and k >= 2) because there are only few such numbers.
I check for every prime whether \sigma_1(p^k) = dfrac{p^{k+1} - 1}{p - 1} is a multiple of 2017.
If yes, then that number including all its multiples (except every p-th multiple) has a divisor sum that is divisible by 2017.
Since p^2 <= 10^11 less than a million number have to be checked which is done in less than a second.
Much more computation time is spent on equation (1):
every prime p where p+1 is a multiple of 2017 and its multiples have a matching divisor sum.
Instead of finding all primes below 10^11 I check every number 2017k - 1 whether it is prime.
The Miller-Rabin test from my toolbox is pretty fast but I had to include a GCC optimization to stay below one minute execution time.
A substantial part of my code is devoted to detecting duplicates: a few number are found multiple times.
For example 12101 is the smallest prime where \sigma_1 is divisible by 2017. The next prime is 24203.
Their product 12101 * 24203 = 292880503 will be found while processing all multiples of 12101 and then again while processing all multiples of 24203.
The container found
is a simple std::vector
because it has pretty much zero data structure overhead (unlike std::set
).
Duplicates (or a "collision") is impossible for the first 12101-1=12100 multiples of a matching prime (since 12101 is the smallest).
To keep my code more generic I simplified that idea and only assume that a collision is impossible for the first 2017-1=2016 multiple.
If the current prime p is larger than sqrt{10^11} then a collision can only occur if the multiple was seen before because it must be smaller than `p.
Therefore I sort the list of primes found so far and perform a lookup with binary search.
All these optimizations have only one goal: reduce the size of found
until it drops below the 256 MByte limit.
When all primes are processed then found
is sorted again to eliminate all duplicates with std::unique
.
Note
I had the solution pretty fast but my code needed about 6 minutes and almost 2 GByte RAM.
Most of the time was spent optimizing the code (e.g. refactor from std::set
to std::vector
).
And while optimizing, I "broke" the algorithm quite a few times ...
Right now my solution has still high memory consumption and execution time.
It's by far the highest ranking expensive solution which doesn't exceed the memory or CPU limits.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho "1000000 2017" | ./565
Output:
Note: the original problem's input 100000000000 2017
cannot be entered
because just copying results is a soft skill reserved for idiots.
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
// ---------- mulmod, powmod and Miller-Rabin test from my toolbox ----------
// return (a*b) % modulo
unsigned long long mulmod(unsigned long long a, unsigned long long b, unsigned long long modulo)
{
// (a * b) % modulo = (a % modulo) * (b % modulo) % modulo
a %= modulo;
b %= modulo;
// fast path
if (a <= 0xFFFFFFF && b <= 0xFFFFFFF)
return (a * b) % modulo;
#ifdef __GNUC__
// based on GCC's 128 bit implementation
return ((unsigned __int128)a * b) % modulo;
#endif
// we might encounter overflows (slow path)
// the number of loops depends on b, therefore try to minimize b
if (b > a)
std::swap(a, b);
// bitwise multiplication
unsigned long long result = 0;
while (a > 0 && b > 0)
{
// b is odd ? a*b = a + a*(b-1)
if (b & 1)
{
result += a;
if (result >= modulo)
result -= modulo;
// skip b-- because the bit-shift at the end will remove the lowest bit anyway
}
// b is even ? a*b = (2*a)*(b/2)
a <<= 1;
if (a >= modulo)
a -= modulo;
// next bit
b >>= 1;
}
return result;
}
// return (base^exponent) % modulo => simple implementation
unsigned long long powmod(unsigned long long base, unsigned long long exponent, unsigned long long modulo)
{
unsigned long long result = 1;
while (exponent > 0)
{
// fast exponentation:
// odd exponent ? a^b = a*a^(b-1)
if (exponent & 1)
result = mulmod(result, base, modulo);
// even exponent ? a^b = (a*a)^(b/2)
base = mulmod(base, base, modulo);
exponent >>= 1;
}
return result;
}
// Miller-Rabin-test
bool isPrime(unsigned long long p)
{
// IMPORTANT: requires mulmod(a, b, modulo) and powmod(base, exponent, modulo)
// some code from https://ronzii.wordpress.com/2012/03/04/miller-rabin-primality-test/
// with optimizations from http://ceur-ws.org/Vol-1326/020-Forisek.pdf
// good bases can be found at http://miller-rabin.appspot.com/
// trivial cases
const unsigned int bitmaskPrimes2to31 = (1 << 2) | (1 << 3) | (1 << 5) | (1 << 7) |
(1 << 11) | (1 << 13) | (1 << 17) | (1 << 19) |
(1 << 23) | (1 << 29); // = 0x208A28Ac
if (p < 31)
return (bitmaskPrimes2to31 & (1 << p)) != 0;
if (p % 2 == 0 || p % 3 == 0 || p % 5 == 0 || p % 7 == 0 || // divisible by a small prime
p % 11 == 0 || p % 13 == 0 || p % 17 == 0)
return false;
if (p < 17 * 19) // we filtered all composite numbers < 17*19, all others below 17*19 must be prime
return true;
// test p against those numbers ("witnesses")
// good bases can be found at http://miller-rabin.appspot.com/
const unsigned int STOP = 0;
const unsigned int TestAgainst1[] = { 377687, STOP };
const unsigned int TestAgainst2[] = { 31, 73, STOP };
const unsigned int TestAgainst3[] = { 2, 7, 61, STOP };
// first three sequences are good up to 2^32
const unsigned int TestAgainst4[] = { 2, 13, 23, 1662803, STOP };
const unsigned int TestAgainst7[] = { 2, 325, 9375, 28178, 450775, 9780504, 1795265022, STOP };
// good up to 2^64
const unsigned int* testAgainst = TestAgainst7;
// use less tests if feasible
if (p < 5329)
testAgainst = TestAgainst1;
else if (p < 9080191)
testAgainst = TestAgainst2;
else if (p < 4759123141ULL)
testAgainst = TestAgainst3;
else if (p < 1122004669633ULL)
testAgainst = TestAgainst4;
// find p - 1 = d * 2^j
auto d = p - 1;
d >>= 1;
unsigned int shift = 0;
while ((d & 1) == 0)
{
shift++;
d >>= 1;
}
// test p against all bases
do
{
auto x = powmod(*testAgainst++, d, p);
// is test^d % p == 1 or -1 ?
if (x == 1 || x == p - 1)
continue;
// now either prime or a strong pseudo-prime
// check test^(d*2^r) for 0 <= r < shift
bool maybePrime = false;
for (unsigned int r = 0; r < shift; r++)
{
// x = x^2 % p
// (initial x was test^d)
x = mulmod(x, x, p);
// x % p == 1 => not prime
if (x == 1)
return false;
// x % p == -1 => prime or an even stronger pseudo-prime
if (x == p - 1)
{
// next iteration
maybePrime = true;
break;
}
}
// not prime
if (!maybePrime)
return false;
} while (*testAgainst != STOP);
// prime
return true;
}
// ---------- problem-specific code ----------
// much faster ... but still takes a few seconds
unsigned long long search(unsigned long long limit, unsigned int multiple)
{
std::vector<unsigned long long> found;
// avoid re-allocations for limit = 10^11
if (limit == 100000000000ULL)
found.reserve(26240000);
// find primes where sigma(prime^2) is divisible by 2017 (same for sigma(prime^3), ...)
for (unsigned long long p = 2; p*p <= limit; p++)
{
if (!isPrime(p))
continue;
// at least p^2
auto power = p * p;
while (power <= limit)
{
// sigma = (p^q - 1) / (p - 1)
auto sigma = (power*p - 1) / (p - 1);
if (sigma % multiple == 0)
// including all multiples
for (auto i = 1; i*power <= limit; i++)
if (i % p != 0) // avoid the case where i is a multiple of p because then they aren't coprime anymore
found.push_back(i*power);
// next iteration will exceed limit ?
if (limit / power < p)
break;
// keep going ...
power *= p;
}
}
// sum of all matches
unsigned long long result = 0;
// switch to "optimized" mode if p^2 > limit
size_t sortedSize = 0;
// sigma(prime) = prime + 1
// => check all numbers 2017k - 1 whether they are prime
for (unsigned long long p = multiple - 1; p <= limit; p += multiple)
{
// only primes ...
if (!isPrime(p))
continue;
// "optimized" mode:
// collisions can only occur when multiplying p by a smaller prime which must be part of the "found" container
if (sortedSize == 0 && p*p > limit)
{
// sort all solutions so that I can search for elements with std::binary_search
std::sort(found.begin(), found.end());
sortedSize = found.size();
}
// sigma(p) is a multiple of 2017 and that's also true for all its multiples
for (unsigned long long i = 1; i*p <= limit; i++)
{
// avoid the case where i is a multiple of p because then they aren't coprime anymore
if (i % p == 0)
continue;
// another solution (which might be a duplicate, though !)
auto current = i * p;
// if i is small then a collision is impossible
if (i < multiple - 1)
{
result += current;
continue;
}
// I can detect collisions immediately if p > sqrt(limit) because then p > i
if (sortedSize > 0)
{
if (!std::binary_search(found.begin(), found.begin() + sortedSize, current))
result += current;
}
else
// potential collision
found.push_back(current);
}
}
// exclude duplicates
std::sort(found.begin(), found.end());
auto duplicates = std::unique(found.begin(), found.end());
// sum of all found numbers (but count duplicates only once)
for (auto i = found.begin(); i != duplicates; i++)
result += *i;
return result;
}
int main()
{
unsigned long long limit = 100000000000ULL; // 10^11
unsigned int multiple = 2017;
std::cin >> limit >> multiple;
std::cout << search(limit, multiple) << std::endl;
return 0;
}
This solution contains 42 empty lines, 64 comments and 6 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in 29.7 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
Peak memory usage was about 207 MByte.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
December 10, 2017 submitted solution
December 10, 2017 added comments
Difficulty
Project Euler ranks this problem at 35% (out of 100%).
Links
projecteuler.net/thread=565 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
C++ github.com/evilmucedin/project-euler/blob/master/euler565/565.cpp (written by Den Raskovalov)
C++ github.com/roosephu/project-euler/blob/master/565.cpp (written by Yuping Luo)
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 | 697 | 698 | 699 | 700 |
701 | 702 | 703 | 704 | 705 | 706 | 707 | 708 | 709 | 710 | 711 | 712 | 713 | 714 | 715 | 716 | 717 | 718 | 719 | 720 | 721 | 722 | 723 | 724 | 725 |
726 | 727 | 728 | 729 | 730 | 731 | 732 | 733 | 734 | 735 | 736 | 737 | 738 | 739 | 740 | 741 | 742 | 743 | 744 | 745 | 746 | 747 | 748 | 749 | 750 |
751 | 752 | 753 | 754 | 755 | 756 | 757 | 758 | 759 | 760 | 761 | 762 | 763 | 764 | 765 | 766 | 767 | 768 | 769 | 770 | 771 | 772 | 773 | 774 | 775 |
776 | 777 | 778 | 779 | 780 | 781 | 782 | 783 | 784 | 785 | 786 | 787 | 788 | 789 | 790 | 791 | 792 | 793 | 794 | 795 | 796 | 797 | 798 | 799 | 800 |
801 | 802 | 803 | 804 | 805 | 806 | 807 | 808 | 809 | 810 | 811 | 812 | 813 | 814 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 563 - Robot Welders | Super Pandigital Numbers - problem 571 >> |